package com.ruoyi.oa.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import com.ruoyi.oa.domain.bo.OaScheduleTemplateBo;
import com.ruoyi.oa.domain.vo.OaScheduleTemplateVo;
import com.ruoyi.oa.domain.OaScheduleTemplate;
import com.ruoyi.oa.mapper.OaScheduleTemplateMapper;
import com.ruoyi.oa.service.IOaScheduleTemplateService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 进度模板主Service业务层处理
 *
 * @author hdka
 * @date 2025-05-08
 */
@RequiredArgsConstructor
@Service
public class OaScheduleTemplateServiceImpl implements IOaScheduleTemplateService {

    private final OaScheduleTemplateMapper baseMapper;

    /**
     * 查询进度模板主
     */
    @Override
    public OaScheduleTemplateVo queryById(Long templateId){
        return baseMapper.selectVoById(templateId);
    }

    /**
     * 查询进度模板主列表
     */
    @Override
    public TableDataInfo<OaScheduleTemplateVo> queryPageList(OaScheduleTemplateBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<OaScheduleTemplate> lqw = buildQueryWrapper(bo);
        Page<OaScheduleTemplateVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询进度模板主列表
     */
    @Override
    public List<OaScheduleTemplateVo> queryList(OaScheduleTemplateBo bo) {
        LambdaQueryWrapper<OaScheduleTemplate> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<OaScheduleTemplate> buildQueryWrapper(OaScheduleTemplateBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<OaScheduleTemplate> lqw = Wrappers.lambdaQuery();
        lqw.like(StringUtils.isNotBlank(bo.getTemplateName()), OaScheduleTemplate::getTemplateName, bo.getTemplateName());
        lqw.eq(bo.getStatus() != null, OaScheduleTemplate::getStatus, bo.getStatus());
        return lqw;
    }

    /**
     * 新增进度模板主
     */
    @Override
    public Boolean insertByBo(OaScheduleTemplateBo bo) {
        OaScheduleTemplate add = BeanUtil.toBean(bo, OaScheduleTemplate.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setTemplateId(add.getTemplateId());
        }
        return flag;
    }

    /**
     * 修改进度模板主
     */
    @Override
    public Boolean updateByBo(OaScheduleTemplateBo bo) {
        OaScheduleTemplate update = BeanUtil.toBean(bo, OaScheduleTemplate.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(OaScheduleTemplate entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 批量删除进度模板主
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }
}
